#include <SparkFun_ADXL345.h>

#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <BlynkSimpleEsp8266.h>

#include <FastLED.h>

boolean wifi_enable = false;
void preinit() {
  ESP8266WiFiClass::preinitWiFiOff();
}

char auth[] = "";
char ssid[] = "WLAN-VTXKHJ";
char pass[] = "HOU08BAKLK32a";


ADXL345 adxl = ADXL345();


#define LED_PIN     13
#define NUM_LEDS    54
#define MAX_BRIGHTNESS  150
#define LED_TYPE    WS2812
#define COLOR_ORDER GRB
CRGB leds[NUM_LEDS];

int updates_per_second = 100;


#define LIPO_MINIMAL 3.2
#define LIPO_MINIMAL_CHARGING 4.2


CRGBPalette16 currentPalette;
TBlendType    currentBlending;

int palette = 0;
int lastPalette = 0;

extern CRGBPalette16 myRedWhiteBluePalette;
extern const TProgmemPalette16 myRedWhiteBluePalette_p PROGMEM;


int current_position = 0;
boolean set_dice = false;
boolean inactivity = false;
boolean activity = false;
int last_sideup = 0;

const int button = 12;
const int latch = 14;


int current_mode = 0;
int n_modes = 4;



int side_x_top[6][6][12] = {
  {{2, 3, 4, 5, 1, 0, 0, 0, 0, 0, 0, 0}, {7, 8, 9, 7, 8, 9, 7, 8, 9, 7, 8, 9}, {4, 5, 6, 4, 5, 6, 4, 5, 6, 4, 5, 6}, {1, 2, 3, 1, 2, 3, 1, 2, 3, 1, 2, 3}, {1, 2, 3, 4, 6, 7, 8, 9, 0, 0, 0, 0}, {5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
  {{5, 6, 3, 1, 2, 0, 0, 0, 0, 0, 0, 0}, {1, 4, 7, 9, 6, 3, 9, 6, 3, 9, 6, 3}, {2, 5, 8, 8, 5, 2, 8, 5, 2, 8, 5, 2}, {3, 6, 9, 7, 4, 1, 7, 4, 1, 7, 4, 1}, {1, 2, 3, 4, 6, 7, 8, 9, 0, 0, 0, 0}, {5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
  {{2, 6, 4, 1, 3, 0, 0, 0, 0, 0, 0, 0}, {1, 4, 7, 7, 8, 9, 9, 6, 3, 3, 2, 1}, {2, 5, 8, 4, 5, 6, 8, 5, 2, 6, 5, 4}, {3, 6, 9, 1, 2, 3, 7, 4, 1, 9, 8, 7}, {1, 2, 3, 4, 6, 7, 8, 9, 0, 0, 0, 0}, {5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
  {{3, 6, 5, 1, 4, 0, 0, 0, 0, 0, 0, 0}, {1, 4, 7, 1, 4, 7, 9, 6, 3, 1, 4, 7}, {2, 5, 8, 2, 5, 8, 8, 5, 2, 2, 5, 8}, {3, 6, 9, 3, 6, 9, 7, 4, 1, 3, 6, 9}, {1, 2, 3, 4, 6, 7, 8, 9, 0, 0, 0, 0}, {5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
  {{4, 6, 2, 1, 5, 0, 0, 0, 0, 0, 0, 0}, {1, 4, 7, 3, 2, 1, 9, 6, 3, 7, 8, 9}, {2, 5, 8, 6, 5, 4, 8, 5, 2, 4, 5, 6}, {3, 6, 9, 9, 8, 7, 7, 4, 1, 1, 2, 3}, {1, 2, 3, 4, 6, 7, 8, 9, 0, 0, 0, 0}, {5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
  {{2, 5, 4, 3, 6, 0, 0, 0, 0, 0, 0, 0}, {3, 2, 1, 3, 2, 1, 3, 2, 1, 3, 2, 1}, {6, 5, 4, 6, 5, 4, 6, 5, 4, 6, 5, 4}, {9, 8, 7, 9, 8, 7, 9, 8, 7, 9, 8, 7}, {1, 2, 3, 4, 6, 7, 8, 9, 0, 0, 0, 0}, {5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}}
};

int dice_number[6][9] = {
  {0, 0, 0, 0, 1, 0, 0, 0, 0},
  {1, 0, 0, 0, 0, 0, 0, 0, 1},
  {1, 0, 0, 0, 1, 0, 0, 0, 1},
  {1, 0, 1, 0, 0, 0, 1, 0, 1},
  {1, 0, 1, 0, 1, 0, 1, 0, 1},
  {1, 0, 1, 1, 0, 1, 1, 0, 1}
};

int current_dicenumber = 0;
int next_dicenumber = 0;



void setup() {
  Serial.begin(115200);
  pinMode(latch, OUTPUT);
  digitalWrite(latch, HIGH);

  pinMode(button, INPUT);

  adxl.powerOn();
  adxl.setRangeSetting(2);

  adxl.setActivityXYZ(1, 1, 1);
  adxl.setActivityThreshold(300);

  adxl.setInactivityXYZ(1, 1, 1);
  adxl.setInactivityThreshold(75);
  adxl.setTimeInactivity(1);

  adxl.setTapDetectionOnXYZ(0, 0, 0);
  adxl.setTapThreshold(50);
  adxl.setTapDuration(15);

  adxl.setDoubleTapLatency(150);
  adxl.setDoubleTapWindow(200);

  adxl.setFreeFallThreshold(7);
  adxl.setFreeFallDuration(30);

  adxl.InactivityINT(1);
  adxl.ActivityINT(1);
  adxl.FreeFallINT(0);
  adxl.doubleTapINT(0);
  adxl.singleTapINT(0);

  FastLED.addLeds<LED_TYPE, LED_PIN, COLOR_ORDER>(leds, NUM_LEDS).setCorrection(TypicalLEDStrip);
  FastLED.setBrightness(30);

  currentPalette = RainbowColors_p;
  currentBlending = LINEARBLEND;
  delay(100);

  for (int i = 0; i < NUM_LEDS; i++) leds[i] = CRGB(0, 100, 0);
  FastLED.show();
  delay(1000);
}


unsigned long t = millis();
unsigned long t_lipo = millis();
unsigned long t_sideup = millis();

void loop() {
  if (wifi_enable) Blynk.run();

  int x, y, z;
  adxl.readAccel(&x, &y, &z);

  int side_up = whichsideup(x, y, z);

  if (current_mode == 0) {
    //################################## MODE 0
    static uint8_t startIndex = 0;
    startIndex = startIndex + 1;

    FillLEDsFromPaletteColors(startIndex);

    FastLED.show();
    FastLED.delay(1000 / updates_per_second);
  }
  else if (current_mode == 1) {
    //################################## MODE 1
    if (side_up > 0 && current_position != side_up) {
      current_position = side_up;

      if (wifi_enable) Blynk.virtualWrite(V0, 255);

      for (int i = 0; i < NUM_LEDS; i++) {
        leds[i] = 0;
      }

      if (current_position == 1) { //blau
        if (wifi_enable) Blynk.setProperty(V0, "color", "#0000FF");
        for (int i = 0; i < 9; i++)
          leds[0 + i] = CRGB(0, 0, 255);
      }
      else if (current_position == 2) { //gelb
        if (wifi_enable) Blynk.setProperty(V0, "color", "#FFFF00");
        for (int i = 0; i < 9; i++)
          leds[9 + i] = CRGB(255, 255, 0);
      }
      else if (current_position == 3) { //rot
        if (wifi_enable) Blynk.setProperty(V0, "color", "#FF0000");
        for (int i = 0; i < 9; i++)
          leds[18 + i] = CRGB(255, 0, 0);
      }
      else if (current_position == 4) { //lila
        if (wifi_enable) Blynk.setProperty(V0, "color", "#FF00FF");
        for (int i = 0; i < 9; i++)
          leds[27 + i] = CRGB(255, 0, 255);
      }
      else if (current_position == 5) { //green
        if (wifi_enable) Blynk.setProperty(V0, "color", "#00FF00");
        for (int i = 0; i < 9; i++)
          leds[36 + i] = CRGB(0, 255, 0);
      }
      if (current_position == 6) { //white
        if (wifi_enable) Blynk.setProperty(V0, "color", "#FFFFFF");
        for (int i = 0; i < 9; i++)
          leds[45 + i] = CRGB(255, 255, 255);
      }
      else {
        //set_frame = false;
      }
      FastLED.show();

      t = millis();
    }
  }
  else if (current_mode == 2) {
    //################################## MODE 2
    if (side_up > 0 && current_position != side_up) {
      current_position = side_up;
      if (wifi_enable) {
        if (side_up == 1) Blynk.setProperty(V0, "color", "#0000FF");
        if (side_up == 2) Blynk.setProperty(V0, "color", "#FFFF00");
        if (side_up == 3) Blynk.setProperty(V0, "color", "#FF0000");
        if (side_up == 4) Blynk.setProperty(V0, "color", "#FF00FF");
        if (side_up == 5) Blynk.setProperty(V0, "color", "#00FF00");
        if (side_up == 6) Blynk.setProperty(V0, "color", "#FFFFFF");
      }

      for (int i = 0; i < NUM_LEDS; i++) leds[i] = CRGB(0, 0, 0);

      int pi = 0;
      for (int a = 0; a < 3; a++) {
        for (int bright = 0; bright < 100; bright += 5) {
          for (int m = 0; m < 4; m++) {
            for (int b = 0; b < 3; b++) {
              pi = (side_x_top[side_up - 1][0][m] - 1) * 9 + side_x_top[side_up - 1][a + 1][b + m * 3] - 1;
              if (side_x_top[side_up - 1][a + 1][b + m * 3] > 0) leds[pi] = get_color_for_side(side_up, bright);
            }
          }
          FastLED.show();
          delay(3);
        }
      }
      for (int a = 0; a < 2; a++) {
        for (int bright = 0; bright < 100; bright += 5) {
          for (int b = 0; b < 12; b++) {
            pi = (side_up - 1) * 9 + side_x_top[side_up - 1][a + 4][b] - 1;
            if (side_x_top[side_up - 1][a + 4][b] > 0) leds[pi] = get_color_for_side(side_up, bright);
          }
          FastLED.show();
          delay(3);
        }
      }
      t = millis();
    }
  }
  else if (current_mode == 3) {
    //################################## MODE 3

    if (set_dice && !activity) {
      next_dicenumber = random(1, 7);
      if (millis() > t_sideup + 400 && side_up > 0) {

        if (wifi_enable) {
          if (side_up == 1) Blynk.setProperty(V0, "color", "#0000FF");
          if (side_up == 2) Blynk.setProperty(V0, "color", "#FFFF00");
          if (side_up == 3) Blynk.setProperty(V0, "color", "#FF0000");
          if (side_up == 4) Blynk.setProperty(V0, "color", "#FF00FF");
          if (side_up == 5) Blynk.setProperty(V0, "color", "#00FF00");
          if (side_up == 6) Blynk.setProperty(V0, "color", "#FFFFFF");
        }

        for (int i = 0; i < NUM_LEDS; i++) leds[i] = CRGB(0, 0, 0);

        int pi = 0;
        for (int a = 0; a < 3; a++) {
          for (int bright = 0; bright < 100; bright += 5) {
            for (int m = 0; m < 4; m++) {
              for (int b = 0; b < 3; b++) {
                pi = (side_x_top[side_up - 1][0][m] - 1) * 9 + side_x_top[side_up - 1][a + 1][b + m * 3] - 1;
                if (side_x_top[side_up - 1][a + 1][b + m * 3] > 0) leds[pi] = get_color_for_side(side_up, bright);
              }
            }
            FastLED.show();
            delay(3);
          }
        }
        for (int a = 0; a < 2; a++) {
          for (int bright = 0; bright < 100; bright += 5) {
            for (int b = 0; b < 12; b++) {
              pi = (side_up - 1) * 9 + side_x_top[side_up - 1][a + 4][b] - 1;
              if (side_x_top[side_up - 1][a + 4][b] > 0) leds[pi] = get_color_for_side(side_up, bright);
            }
            FastLED.show();
            delay(3);
          }
        }

        CRGB col = get_color_for_side(side_up, 100);
        for (int i = 0; i < 9; i++) leds[(side_up - 1) * 9 + i] = 0;
        for (int i = 0; i < 9; i++) {
          if (dice_number[next_dicenumber - 1][i] > 0) leds[(side_up - 1) * 9 + i] = get_color_for_side(side_up, 200);
        }
        FastLED.show();
        delay(2000);


        t = millis();
        set_dice = false;
      }
    }
  }




  ADXL_ISR();

  ReadButton();

  AutoOff(t, 20);

  CheckLIPO(t_lipo);
}



void ADXL_ISR() {
  byte interrupts = adxl.getInterruptSource();

  // Free Fall Detection
  if (adxl.triggered(interrupts, ADXL345_FREE_FALL)) {

  }

  // Inactivity
  if (adxl.triggered(interrupts, ADXL345_INACTIVITY)) {
    //for (int i = 0; i < NUM_LEDS; i++) leds[i] = CRGB(100, 0, 0);
    //FastLED.show();
    if (activity) {
      set_dice = true;
      t_sideup = millis();
    }
    //inactivity = true;
    activity = false;
  }

  // Activity
  if (adxl.triggered(interrupts, ADXL345_ACTIVITY)) {
    //inactivity = false;
    activity = true;
    for (int i = 0; i < NUM_LEDS; i++) leds[i] = CRGB(0, 100, 0);
    FastLED.show();
  }

  // Double Tap Detection
  if (adxl.triggered(interrupts, ADXL345_DOUBLE_TAP)) {

  }

  // Tap Detection
  if (adxl.triggered(interrupts, ADXL345_SINGLE_TAP)) {
    //tap = !tap;
  }
}


void ReadButton() {
  if (digitalRead(button) == 1) {
    int button_read = 0;
    unsigned long pressed = millis();
    while (digitalRead(button)) {
      if (millis() > pressed + 5000) {
        button_read = 3;
        for (int i = 0; i < NUM_LEDS; i++) leds[i] = CRGB(0, 0, 100);
        FastLED.show();
      }
      else if (millis() > pressed + 3000) {
        button_read = 2;
        for (int i = 0; i < NUM_LEDS; i++) leds[i] = CRGB(100, 0, 0);
        FastLED.show();
      }
      else if (millis() > pressed + 1000) {
        button_read = 1;
        for (int i = 0; i < NUM_LEDS; i++) leds[i] = CRGB(0, 100, 0);
        FastLED.show();
      }
      delay(20);
    }
    delay(100);

    switch (button_read) {
      case 0:
        if (current_mode < n_modes - 1) current_mode++;
        else current_mode = 0;
        break;
      case 1:
        for (int i = 0; i < 54; i++) leds[i] = CRGB(100, 100, 100);
        for (int i = 0; i < 6; i++) leds[4 + i * 9] = CRGB(100, 0, 0);
        FastLED.show();
        if (wifi_enable == false) Blynk.begin(auth, ssid, pass, IPAddress(139, 59, 206, 133), 80);
        for (int i = 0; i < 6; i++) leds[4 + i * 9] = CRGB(0, 150, 0);
        FastLED.show();
        delay(1000);
        wifi_enable = true;
        break;
      case 2:
        digitalWrite(latch, LOW);
        delay(1000);
        break;
    }

    t = millis();
  }
}


void FillLEDsFromPaletteColors( uint8_t colorIndex) {
  uint8_t brightness = 255;

  for ( int i = 0; i < NUM_LEDS; i++) {
    leds[i] = ColorFromPalette( currentPalette, colorIndex, brightness, currentBlending);
    colorIndex += 3;
  }
}


void SetupTotallyRandomPalette() {
  for ( int i = 0; i < 16; i++) {
    currentPalette[i] = CHSV( random8(), 255, random8());
  }
}

void SetupBlackAndWhiteStripedPalette() {
  // 'black out' all 16 palette entries...
  fill_solid( currentPalette, 16, CRGB::Black);
  // and set every fourth one to white.
  currentPalette[0] = CRGB::White;
  currentPalette[4] = CRGB::White;
  currentPalette[8] = CRGB::White;
  currentPalette[12] = CRGB::White;

}

// This function sets up a palette of purple and green stripes.
void SetupPurpleAndGreenPalette() {
  CRGB purple = CHSV( HUE_PURPLE, 255, 255);
  CRGB green  = CHSV( HUE_GREEN, 255, 255);
  CRGB black  = CRGB::Black;

  currentPalette = CRGBPalette16(
                     green,  green,  black,  black,
                     purple, purple, black,  black,
                     green,  green,  black,  black,
                     purple, purple, black,  black );
}

const TProgmemPalette16 myRedWhiteBluePalette_p PROGMEM = {
  CRGB::Red,
  CRGB::Gray, // 'white' is too bright compared to red and blue
  CRGB::Blue,
  CRGB::Black,

  CRGB::Red,
  CRGB::Gray,
  CRGB::Blue,
  CRGB::Black,

  CRGB::Red,
  CRGB::Red,
  CRGB::Gray,
  CRGB::Gray,
  CRGB::Blue,
  CRGB::Blue,
  CRGB::Black,
  CRGB::Black
};


int whichsideup(int _x, int _y, int _z) {
  int up = 0;
  if (inbetween(_x, -20, 20) && inbetween(_y, -20, 20) && _z < -30) up = 1;
  else if (_x > 30 && inbetween(_y, -20, 20) && inbetween(_z, -20, 20)) up = 2;
  else if (inbetween(_x, -20, 20) && _y < -30 && inbetween(_z, -20, 20)) up = 3;
  else if (_x < -30 && inbetween(_y, -20, 20) && inbetween(_z, -20, 20)) up = 4;
  else if (inbetween(_x, -20, 20) && _y > 30 && inbetween(_z, -20, 20)) up = 5;
  else if (inbetween(_x, -20, 20) && inbetween(_y, -20, 20) && _z > 30) up = 6;
  return up;
}

CRGB get_color_for_side(int s, int brigthness) {
  CRGB c = 0;
  if (s == 1) c = CRGB(0, 0, brigthness); //blue
  else if (s == 2) c = CRGB(brigthness, brigthness, 0); //yellow
  else if (s == 3) c = CRGB(brigthness, 0, 0); //red
  else if (s == 4) c = CRGB(brigthness, 0, brigthness); //lila
  else if (s == 5) c = CRGB(0, brigthness, 0); //green
  else if (s == 6) c = CRGB(brigthness, brigthness, brigthness); //white
  return c;
}


boolean inbetween(int value, int mi, int ma) {
  boolean result = false;
  if (value > mi && value < ma) result = true;
  return result;
}

int get_pixel(int mat, int px, int py) {
  //starting at top left corner
  return (px + py * 3) + mat * 9;
}



void AutoOff(unsigned long & ti, int offtime) {
  if (millis() > ti + offtime * 1000) { //auto off
    for (int i = 0; i < 54; i++) leds[i] = CRGB(100, 0, 0);
    FastLED.show();

    delay(500);
    digitalWrite(latch, LOW);
    delay(1000);
  }
}

void CheckLIPO(unsigned long & ti) {
  if (millis() > ti + 5000) {

    int v = getBatteryVoltage();
    if (wifi_enable) Blynk.virtualWrite(V2, v);

    if (v < LIPO_MINIMAL) {
      //battery empty

    }
    else if (v > LIPO_MINIMAL_CHARGING) {
      //battery is charging

    }
    ti = millis();
  }
}


int getBatteryVoltage() {
  // U = (R2)/(R1+R2) * U_lipo
  // U = factor * U_lipo

  //Uout = r2/(r1+r2) * Uin
  //Uin = 5v
  //Uout = 1v max
  //Uin = Uout * (r1+r2)/r2
  //(r1+r2)/r2=

  // 118/18
  float factor = 6.43;
  return (float(analogRead(0)) / 1023.0 * factor) * 1000.0; //returns mV
  //Serial.println(bat);
}
